# Get the base cooldown value
data modify storage minions:zprivate string set from entity @s equipment.head.components."minecraft:profile".properties[{name:"cooldown"}].value

scoreboard players set #Value Minion.Calc 0
function minion:handler/calc/str_to_int
scoreboard players operation #Cooldown Minion.Calc = #Value Minion.Calc

# tellraw @a[tag=Minion.Listening] {text:"Cooldown: ",color:"green",bold:true,italic:false}

# Upgrade formula = (cooldown * 90) / 100
scoreboard players operation #Cooldown Minion.Calc *= $90 Minion.Calc
scoreboard players operation #Cooldown Minion.Calc /= $100 Minion.Calc

execute store result storage minions:zprivate minion.new_cooldown int 1 run scoreboard players get #Cooldown Minion.Calc
data modify entity @s equipment.head.components."minecraft:profile".properties[{name:"cooldown"}].value set string storage minions:zprivate minion.new_cooldown

# --------------------------------------------------------------------------------- #

# Get the base max storage
data modify storage minions:zprivate string set from entity @s equipment.head.components."minecraft:profile".properties[{name:"storage"}].signature

scoreboard players set #Value Minion.Calc 0
function minion:handler/calc/str_to_int

# Upgrade formula = max_storage * 1.25
execute store result storage minions:zprivate minion.new_max_storage int 1.25 run scoreboard players get #Value Minion.Calc
data modify entity @s equipment.head.components."minecraft:profile".properties[{name:"storage"}].signature set string storage minions:zprivate minion.new_max_storage

# Check for special minions with a max storage cap
execute store result score #NewMaxStorage Minion.Calc run data get storage minions:zprivate minion.new_max_storage

execute if score #NewMaxStorage Minion.Calc matches 101.. as @s if data entity @s equipment.head.components."minecraft:profile".properties[{name:"type",value:"lava"}] run return run data modify entity @s equipment.head.components."minecraft:profile".properties[{name:"storage"}].signature set value "100"